package edu.sdsc.sirius.dialogs;

// GUI
import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.*;

// MBT
import edu.sdsc.mbt.*;
import edu.sdsc.sirius.util.Manager;
import edu.sdsc.sirius.viewers.*;

public class RotateBondDialog extends JDialog implements DisplayDialog {

//  Add for internationalization
	Locale locale;
	private ResourceBundle reslang;
	reslang = ResourceBundle.getBundle("SiriusLangRes", locale);
	private String[] _M_Symbol = new String[10];
// end

	private JFrame parentFrame;
	private Manager parent;
	private StructureViewer sv;
	private Atom[] atoms = new Atom[2];
	
	private DisplayDialog itself;

	private Container contentPane;
	private JPanel base = new JPanel();
	
	
	private JLabel label1 = new JLabel();
	private JTextField field1 = new JTextField(30);
	private JLabel label2 = new JLabel();
	private JTextField field2 = new JTextField(30);
	
	private JButton okButton = new JButton("OK");
// 	private JButton cancelButton = new JButton("Cancel");
_M_Symbol[0] = (String)reslang.getObject("M_Cancel")
	private JButton cancelButton = new JButton(_M_Symbol[0]);
	
	private JTextField activeField = field1;//is used to figure out which field should accept pick input from StructureViewer
	
// 	private JCheckBox check = new JCheckBox("Monitor steric clashes");
_M_Symbol[0] = (String)reslang.getObject("M_Monitorstericclash")
	private JCheckBox check = new JCheckBox(_M_Symbol[0]);
	
	public RotateBondDialog(JFrame f, Manager p, StructureViewer s){
	
// 		super(f, "Define bond to rotate around", false);
_M_Symbol[0] = (String)reslang.getObject("M_Definebondtorotate")
		super(f, _M_Symbol[0], false);
	
		parentFrame = f;
		parent = p;
		sv = s;
		
//		System.out.println("Starting");
		
		parent.setDisplayDialogStatus(true);
		
		itself = this;
		
		//create the panels
		contentPane = getContentPane();
		contentPane.setLayout(null);
		
		base.setPreferredSize(new Dimension(210, 160));
		base.setBorder(new BevelBorder(BevelBorder.RAISED));
		base.setLocation(new Point(5,5));
		base.setBounds(5, 5, 210, 160);
		base.setLayout(null);
		
		
		//object field
		label1.setForeground(Color.black);
		label1.setFont(new Font("Dialog", Font.PLAIN, 12));
// 		label1.setText("1st atom: enter name or click");
_M_Symbol[0] = (String)reslang.getObject("M_statomenternameorc")
		label1.setText(_M_Symbol[0]);
		label1.setPreferredSize(new Dimension(170,20));
		label1.setBounds(15,15,190,20);
		label1.setLocation(new Point(15,15));
		label1.setVisible(true);
		
		field1.setPreferredSize(new Dimension(170,20));
		field1.setBounds(15,40,170,20);
		field1.setLocation(new Point(15,40));
		field1.setEditable(true);
		field1.setEnabled(true);
		field1.setVisible(true);
		field1.addMouseListener(new MouseAdapter(){
			public void mouseClicked(MouseEvent m){
				activeField = field1;
			}
		});
		
		label2.setForeground(Color.black);
		label2.setFont(new Font("Dialog", Font.PLAIN, 12));
// 		label2.setText("2nd atom: enter name or click");
_M_Symbol[0] = (String)reslang.getObject("M_ndatomenternameorc")
		label2.setText(_M_Symbol[0]);
		label2.setPreferredSize(new Dimension(190,20));
		label2.setBounds(15,65,190,20);
		label2.setLocation(new Point(15,65));
		label2.setVisible(true);
		
		field2.setPreferredSize(new Dimension(170,20));
		field2.setBounds(15,90,170,20);
		field2.setLocation(new Point(15,90));
		field2.setEditable(true);
		field2.setEnabled(true);
		field2.setVisible(true);
		field2.addMouseListener(new MouseAdapter(){
			public void mouseClicked(MouseEvent m){
				activeField = field2;
			}
		});
		
		check.setSelected(false);
		check.setLocation(15,125);
		check.setBounds(15,125,180,20);
		check.setVisible(true);
		
		
		base.add(label1);
		base.add(field1);
		base.add(label2);
		base.add(field2);
		base.add(check);
		
		//buttons
		okButton.setPreferredSize(new Dimension(80,25));
		okButton.setLocation(new Point(20, 170));
		okButton.setBounds(20, 170, 80, 25);
		okButton.setVisible(true);
		okButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
			
				//add error checking for selection bounds
				//eg., selection level is residue, but entered only structure name
				try{
					setVisible(false);
					parent.setDisplayDialogStatus(false);
					if (atoms[0] == null || atoms[1] == null || field1.getText().length() == 0 || field2.getText().length() == 0){
// 						parent.displayErrorMessage("Two atoms must be selected to define a bond");
_M_Symbol[0] = (String)reslang.getObject("M_Twoatomsmustbesele")
						parent.displayErrorMessage(_M_Symbol[0]);
					}
					else{
						StructureEvent event = new StructureEvent(itself);
						event.atomLabels.add(field1.getText());
						event.atomLabels.add(field2.getText());
						event.atoms.add(atoms[0]);
						event.atoms.add(atoms[1]);
						event.check = check.isSelected();
						event.eventType = StructureEventRegistry.ROTATE_BOND;
						sv.processDisplayDialogEvent(event);
					}
				}
				catch (Exception e){
					setVisible(false);
					parent.setDisplayDialogStatus(false);
// 					parent.displayExceptionMessage("Exception rotating around a bond", e);
_M_Symbol[0] = (String)reslang.getObject("M_Exceptionrotatinga")
					parent.displayExceptionMessage(_M_Symbol[0], e);
				}

				dispose();
			}
		});
		
		
		cancelButton.setPreferredSize(new Dimension(80,25));
		cancelButton.setLocation(new Point(120, 170));
		cancelButton.setBounds(120, 170, 80, 25);
		cancelButton.setVisible(true);
		cancelButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				setVisible(false);
				parent.setDisplayDialogStatus(false);
				dispose();
			}
		});
		
		
		contentPane.add(base);
		contentPane.add(okButton);
		contentPane.add(cancelButton);
		
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				setVisible(false);
				parent.setDisplayDialogStatus(false);
				dispose();
			}
			
			public void windowDeactivated(WindowEvent e){
				toFront();
			}
		});
		
		
		
		setSize(230, 225);

		//add this to accommodate both applet and application cases
		if (parentFrame == null){
//			setLocationRelativeTo(null);
			setBounds(0, 0, getSize().width, getSize().height);
		}
		else{
		
			//set location
			Dimension d1 = getSize();
			Dimension d2 = parentFrame.getSize();
		
//			int x = Math.max((d2.width - d1.width)/2, 0);
//			int y = Math.max((d2.height - d1.height)/2, 0);

			int x = 5 + DialogConstants.toolbarWidth;
			int y = DialogConstants.level + DialogConstants.toolbarHeight;
		
			setBounds(x + parentFrame.getX(), y + parentFrame.getY(), d1.width, d1.height);
		}



		setVisible(true);
		


	}
	
	public void processPick(String data, StructureComponent structureComponent){

		activeField.setText(data);
		//move focus along only if something has been picked
		if (data.length() > 0){
			if (activeField == field1){
				atoms[0] = (Atom)structureComponent;
				activeField = field2;
				field2.requestFocus();
			}
			else{
				atoms[1] = (Atom)structureComponent;
			}
		}
	}
	
}
